-- Generated by Ora2Pg, the Oracle database Schema converter, version 20.0
-- Copyright 2000-2019 Gilles DAROLD. All rights reserved.
-- DATASOURCE: dbi:Oracle:host=oracle11g;sid=xe;port=1521

SET client_encoding TO 'UTF8';

\set ON_ERROR_STOP ON

CREATE SCHEMA hr;
ALTER SCHEMA hr OWNER TO hr;

SET search_path = hr;

CREATE TABLE countries (
	country_id char(2) NOT NULL,
	country_name varchar(40),
	region_id bigint
) ;
COMMENT ON TABLE countries IS E'country table. Contains 25 rows. References with locations table.';
COMMENT ON COLUMN countries.country_id IS E'Primary key of countries table.';
COMMENT ON COLUMN countries.region_id IS E'Region ID for the country. Foreign key to region_id column in the departments table.';
COMMENT ON COLUMN countries.country_name IS E'Country name';
ALTER TABLE countries OWNER TO hr;
ALTER TABLE countries ADD PRIMARY KEY (country_id);

CREATE TABLE departments (
	department_id smallint NOT NULL,
	department_name varchar(30) NOT NULL,
	manager_id integer,
	location_id smallint
) ;
COMMENT ON TABLE departments IS E'Departments table that shows details of departments where employees
work. Contains 27 rows; references with locations, employees, and job_history tables.';
COMMENT ON COLUMN departments.department_name IS E'A not null column that shows name of a department. Administration,
Marketing, Purchasing, Human Resources, Shipping, IT, Executive, Public
Relations, Sales, Finance, and Accounting. ';
COMMENT ON COLUMN departments.department_id IS E'Primary key column of departments table.';
COMMENT ON COLUMN departments.manager_id IS E'Manager_id of a department. Foreign key to employee_id column of employees table. The manager_id column of the employee table references this column.';
COMMENT ON COLUMN departments.location_id IS E'Location id where a department is located. Foreign key to location_id column of locations table.';
ALTER TABLE departments OWNER TO hr;
CREATE INDEX dept_location_ix ON departments (location_id);
ALTER TABLE departments ADD PRIMARY KEY (department_id);

CREATE TABLE employees (
	employee_id integer NOT NULL,
	first_name varchar(20),
	last_name varchar(25) NOT NULL,
	email varchar(25) NOT NULL,
	phone_number varchar(20),
	hire_date timestamp NOT NULL,
	job_id varchar(10) NOT NULL,
	salary double precision,
	commission_pct real,
	manager_id integer,
	department_id smallint
) ;
COMMENT ON TABLE employees IS E'employees table. Contains 107 rows. References with departments,
jobs, job_history tables. Contains a self reference.';
COMMENT ON COLUMN employees.email IS E'Email id of the employee';
COMMENT ON COLUMN employees.employee_id IS E'Primary key of employees table.';
COMMENT ON COLUMN employees.salary IS E'Monthly salary of the employee. Must be greater
than zero (enforced by constraint emp_salary_min)';
COMMENT ON COLUMN employees.hire_date IS E'Date when the employee started on this job. A not null column.';
COMMENT ON COLUMN employees.last_name IS E'Last name of the employee. A not null column.';
COMMENT ON COLUMN employees.job_id IS E'Current job of the employee; foreign key to job_id column of the
jobs table. A not null column.';
COMMENT ON COLUMN employees.phone_number IS E'Phone number of the employee; includes country code and area code';
COMMENT ON COLUMN employees.department_id IS E'Department id where employee works; foreign key to department_id
column of the departments table';
COMMENT ON COLUMN employees.manager_id IS E'Manager id of the employee; has same domain as manager_id in
departments table. Foreign key to employee_id column of employees table.
(useful for reflexive joins and CONNECT BY query)';
COMMENT ON COLUMN employees.first_name IS E'First name of the employee. A not null column.';
COMMENT ON COLUMN employees.commission_pct IS E'Commission percentage of the employee; Only employees in sales
department elgible for commission percentage';
ALTER TABLE employees OWNER TO hr;
CREATE INDEX emp_department_ix ON employees (department_id);
CREATE UNIQUE INDEX emp_email_uk ON employees (email varchar_pattern_ops);
CREATE INDEX emp_job_ix ON employees (job_id varchar_pattern_ops);
CREATE INDEX emp_manager_ix ON employees (manager_id);
CREATE INDEX emp_name_ix ON employees (last_name varchar_pattern_ops, first_name varchar_pattern_ops);
ALTER TABLE employees ADD PRIMARY KEY (employee_id);
ALTER TABLE employees ADD UNIQUE (email);
ALTER TABLE employees ADD CONSTRAINT emp_salary_min CHECK (salary > 0);

CREATE TABLE jobs (
	job_id varchar(10) NOT NULL,
	job_title varchar(35) NOT NULL,
	min_salary integer,
	max_salary integer
) ;
COMMENT ON TABLE jobs IS E'jobs table with job titles and salary ranges. Contains 19 rows.
References with employees and job_history table.';
COMMENT ON COLUMN jobs.job_title IS E'A not null column that shows job title, e.g. AD_VP, FI_ACCOUNTANT';
COMMENT ON COLUMN jobs.job_id IS E'Primary key of jobs table.';
COMMENT ON COLUMN jobs.max_salary IS E'Maximum salary for a job title';
COMMENT ON COLUMN jobs.min_salary IS E'Minimum salary for a job title.';
ALTER TABLE jobs OWNER TO hr;
CREATE UNIQUE INDEX job_id_pk ON jobs (job_id varchar_pattern_ops);
ALTER TABLE jobs ADD PRIMARY KEY (job_id);

CREATE TABLE job_history (
	employee_id integer NOT NULL,
	start_date timestamp NOT NULL,
	end_date timestamp NOT NULL,
	job_id varchar(10) NOT NULL,
	department_id smallint
) ;
COMMENT ON TABLE job_history IS E'Table that stores job history of the employees. If an employee
changes departments within the job or changes jobs within the department,
new rows get inserted into this table with old job information of the
employee. Contains a complex primary key: employee_id+start_date.
Contains 25 rows. References with jobs, employees, and departments tables.';
COMMENT ON COLUMN job_history.start_date IS E'A not null column in the complex primary key employee_id+start_date.
Must be less than the end_date of the job_history table. (enforced by
constraint jhist_date_interval)';
COMMENT ON COLUMN job_history.employee_id IS E'A not null column in the complex primary key employee_id+start_date.
Foreign key to employee_id column of the employee table';
COMMENT ON COLUMN job_history.job_id IS E'Job role in which the employee worked in the past; foreign key to
job_id column in the jobs table. A not null column.';
COMMENT ON COLUMN job_history.department_id IS E'Department id in which the employee worked in the past; foreign key to deparment_id column in the departments table';
COMMENT ON COLUMN job_history.end_date IS E'Last day of the employee in this job role. A not null column. Must be
greater than the start_date of the job_history table.
(enforced by constraint jhist_date_interval)';
ALTER TABLE job_history OWNER TO hr;
CREATE INDEX jhist_department_ix ON job_history (department_id);
CREATE INDEX jhist_employee_ix ON job_history (employee_id);
CREATE INDEX jhist_job_ix ON job_history (job_id varchar_pattern_ops);
ALTER TABLE job_history ADD PRIMARY KEY (employee_id,start_date);
ALTER TABLE job_history ADD CONSTRAINT jhist_date_interval CHECK (end_date > start_date);

CREATE TABLE locations (
	location_id smallint NOT NULL,
	street_address varchar(40),
	postal_code varchar(12),
	city varchar(30) NOT NULL,
	state_province varchar(25),
	country_id char(2)
) ;
COMMENT ON TABLE locations IS E'Locations table that contains specific address of a specific office,
warehouse, and/or production site of a company. Does not store addresses /
locations of customers. Contains 23 rows; references with the
departments and countries tables. ';
COMMENT ON COLUMN locations.street_address IS E'Street address of an office, warehouse, or production site of a company.
Contains building number and street name';
COMMENT ON COLUMN locations.state_province IS E'State or Province where an office, warehouse, or production site of a
company is located.';
COMMENT ON COLUMN locations.country_id IS E'Country where an office, warehouse, or production site of a company is
located. Foreign key to country_id column of the countries table.';
COMMENT ON COLUMN locations.city IS E'A not null column that shows city where an office, warehouse, or
production site of a company is located. ';
COMMENT ON COLUMN locations.postal_code IS E'Postal code of the location of an office, warehouse, or production site
of a company. ';
COMMENT ON COLUMN locations.location_id IS E'Primary key of locations table';
ALTER TABLE locations OWNER TO hr;
CREATE INDEX loc_city_ix ON locations (city varchar_pattern_ops);
CREATE INDEX loc_country_ix ON locations (country_id);
CREATE INDEX loc_state_province_ix ON locations (state_province varchar_pattern_ops);
ALTER TABLE locations ADD PRIMARY KEY (location_id);

CREATE TABLE regions (
	region_id bigint NOT NULL,
	region_name varchar(25)
) ;
ALTER TABLE regions OWNER TO hr;
ALTER TABLE regions ADD PRIMARY KEY (region_id);
ALTER TABLE job_history ADD CONSTRAINT jhist_job_fk FOREIGN KEY (job_id) REFERENCES jobs(job_id) ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;

ALTER TABLE job_history ADD CONSTRAINT jhist_dept_fk FOREIGN KEY (department_id) REFERENCES departments(department_id) ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;

ALTER TABLE job_history ADD CONSTRAINT jhist_emp_fk FOREIGN KEY (employee_id) REFERENCES employees(employee_id) ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;
ALTER TABLE departments ADD CONSTRAINT dept_mgr_fk FOREIGN KEY (manager_id) REFERENCES employees(employee_id) ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;

ALTER TABLE departments ADD CONSTRAINT dept_loc_fk FOREIGN KEY (location_id) REFERENCES locations(location_id) ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;
ALTER TABLE locations ADD CONSTRAINT loc_c_id_fk FOREIGN KEY (country_id) REFERENCES countries(country_id) ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;
ALTER TABLE employees ADD CONSTRAINT emp_dept_fk FOREIGN KEY (department_id) REFERENCES departments(department_id) ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;

ALTER TABLE employees ADD CONSTRAINT emp_job_fk FOREIGN KEY (job_id) REFERENCES jobs(job_id) ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;

ALTER TABLE employees ADD CONSTRAINT emp_manager_fk FOREIGN KEY (manager_id) REFERENCES employees(employee_id) ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;
ALTER TABLE countries ADD CONSTRAINT countr_reg_fk FOREIGN KEY (region_id) REFERENCES regions(region_id) ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;
